﻿using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp5
{
    public partial class Form1 : Form
    {
        private Infragistics.Win.Appearance DropHighlightAppearance;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.DropHighlightAppearance = new Infragistics.Win.Appearance();
            this.DropHighlightAppearance.BackColor = Color.Red;
            this.DropHighlightAppearance.ForeColor = Color.White;

            var dt1 = DummyDataCreator.GetData(30, new Type[] { typeof(string), typeof(string), typeof(string) });
            var dt2 = DummyDataCreator.GetData(30, new Type[] { typeof(string), typeof(string), typeof(string) });

            this.ultraGrid1.InitializeLayout += UltraGrid1_InitializeLayout;
            this.ultraGrid2.InitializeLayout += UltraGrid2_InitializeLayout;
            this.ultraGrid1.SetDataBinding(dt1, null);
            this.ultraGrid2.SetDataBinding(dt2, null);

            this.ultraGrid1.SelectionDrag += UltraGrid1_SelectionDrag;
            this.ultraGrid2.DragOver += UltraGrid2_DragOver;
            this.ultraGrid2.DragLeave += UltraGrid2_DragLeave; ;
        }       

        private void UltraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var ov = layout.Override;
            ov.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
        }

        private void UltraGrid2_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            var layout = e.Layout;
            var ov = layout.Override;
            ov.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
        }

        private void UltraGrid1_SelectionDrag(object sender, CancelEventArgs e)
        {
            var grid = (UltraGrid)sender;
            grid.DoDragDrop(grid.Selected.Rows, DragDropEffects.Copy);
        }

        private void UltraGrid2_DragOver(object sender, DragEventArgs e)
        {
            this.VerifyDropHighlightRow(e);
        }
      
        private void UltraGrid2_DragLeave(object sender, EventArgs e)
        {
            this.DropHightlightRow = null;
        }

        private UltraGridRow dropHightlightRow;
        public UltraGridRow DropHightlightRow
        {
            get
            {
                return this.dropHightlightRow;
            }
            set
            {
                if (value == this.dropHightlightRow)
                    return;

                if (null != this.dropHightlightRow)
                    this.dropHightlightRow.Appearance = null;

                this.dropHightlightRow = value;
                if (null != this.dropHightlightRow)
                    this.dropHightlightRow.Appearance = this.DropHighlightAppearance;
            }
        }

        private void VerifyDropHighlightRow(DragEventArgs e)
        {
            UltraGridRow row = null;
            Point point = this.ultraGrid2.PointToClient(new Point(e.X, e.Y));
            UIElement element = ultraGrid2.DisplayLayout.UIElement.ElementFromPoint(point);
            if (element != null)
                row = element.GetContext(typeof(UltraGridRow)) as UltraGridRow;

            this.DropHightlightRow = row;
        }
    }
}
